/****************************************************************
This file is part of LIME.

LIME is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

LIME is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LIME.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/
#include UNIX

/* Rather than declaring the processing elements in order, in this 
 * module, we name one as process_before and another one as process_after,
 * which implies that we need to specify a schedule array at the
 * end, since lexographic order and execution order do not
 * coincide...
 */
void process_before(const unsigned int buf1[restrict SPLIT_BUF_SIZE],
	      unsigned int obuf[restrict BUF_SIZE])
{
	unsigned int i;
	for(i=0; i< SPLIT_BUF_SIZE; i++)
		obuf[i]=buf1[i];
}
void process_after(const unsigned int buf2[restrict BUF_SIZE-SPLIT_BUF_SIZE],
	      unsigned int obuf[restrict BUF_SIZE])
{
	unsigned int i;
	for(i=SPLIT_BUF_SIZE; i< BUF_SIZE; i++)
		obuf[i]=buf2[i-SPLIT_BUF_SIZE];
}

#if defined(__LIME__)
void (*schedule[])() = {
process_before,
process_after,
};
#endif
