/****************************************************************
This header file contains common definitions used by LIME. KISS.

Copyright 2008 Pjotr Kourzanov

This file is part of LIME.

LIME is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

LIME is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LIME.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/
#ifndef __GLOBAL__
#define __GLOBAL__

// Common defines
// g is the granule size
#define round_up(t,g)	(sizeof(t)/(g)+!!(sizeof(t) % (g)))
#define roundup(s,g)	((s)/(g)+!!((s) % (g)))

// l is log2 of the granule size
#define log_round(t,l)	(1+(((sizeof(t)-1) & ~((1<<(l))-1))>>(l)))
#define loground(s,l)	(1+((((s)-1) & ~((1<<(l))-1))>>(l)))

#endif//__GLOBAL__
