##################################################################
# This AWK script contains functions commonly used in LIME.
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################

BEGIN { if (!STDERR) STDERR="/dev/stderr" }

func suff(a,b) { return a (a ? b : "") }
func pref(a,b) { return (a ? b : "") a }
func alt(a,b) { return a ? a : b }
func wrap(a,b,c) { return a ? b a c : "" }

func append(a,b,c)  { return a (a ? (c ? c : (b ? " " : "")) : "") b }

func prepend(a,b,c) { return b (b ? (c ? c : (a ? " " : "")) : "") a }

func space(n, c, r,i) {
	for (i=1; i<=n; i++) r=r (c ? c : " ");
	return r
}
func prind(l,msg) { print space(l*2) msg }
func fail(msg) { print "ERROR:" f ":" msg > STDERR; exit(1) }
func warn(msg) { print "WARN:" f ":" msg > STDERR }

func handle_xlink(t,b) {
    if (t == "@xlink:type") return type[lev]=b
    if (t == "@xlink:label") return label[lev]=b
    if (t == "@xlink:from") return from[lev]=b
    if (t == "@xlink:to") return to[lev]=b
    if (t == "@xlink:href") {
	if (split(b,href,"#")!=2) fail("can not split href:" b " " state)
	return b
    }

    return ""
}

