#!/usr/bin/awk -f
##################################################################
# This AWK script extracts "forward declarations" of data-types
# (e.g. struct foo; union bar; enum baz;) given a C file
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################
BEGIN { if (!OP) OP="text" }

match($0,/^[[:space:]]*([a-z$A-Z_][a-z$A-Z_0-9]*)[[:space:]]+([a-z$A-Z_][a-z$A-Z_0-9]*)[[:space:]]*;[[:space:]]*$/,el) &&
el[1] ~ /(enum|union|struct)/ {
	name[++nimports]=el[1] " " el[2]
	type[nimports]=el[1]
	imports[name[nimports]]=nimports
}

match($0,/^[[:space:]]*typedef[[:space:]]+(const[[:space:]]+|volatile[[:space:]]+|)([a-z$A-Z_][a-z$A-Z_0-9]*)[[:space:]]+([a-z$A-Z_][a-z$A-Z_0-9]*)[[:space:]]+([a-z$A-Z_][a-z$A-Z_0-9]*)([[:space:]]*\[[^]]+\])?[[:space:]]*;[[:space:]]*$/,el) &&
el[2] ~ /(enum|union|struct)/ {
	name[++nimports]=el[4]
	n=el[2] " " el[3]
	typedef[nimports]=n
	if (!imports[n]) {
		name[++nimports]=n
		type[nimports]=el[2]
		imports[n]=nimports
	}
}

END {
	for (i=1; i<=nimports; i++) if(type[i]) {
	    if (OP=="xml") {
		print "<typedecl><id>" name[i] "</id>"
		print space(2) "<type>" type[i] "</type></typedecl>"
	    }
	    if (OP=="text") print name[i]
	}
}

func space(n, r,i) {
	for (i=1; i<=n; i++) r=r " ";
	return r
}
